Loading...
Searching...
No Matches
etl::array_wrapper< T, SIZE_, ARRAY_ > Class Template Reference

Array wrapper. More...

`#include <array_wrapper.h>`

## Public Types

enum | { SIZE = SIZE_ , MAX_SIZE = SIZE_ , FRONT = 0 , BACK = SIZE - 1 , BEGIN = 0 , END = SIZE , RBEGIN = SIZE - 1 , REND = -1 }
typedef T | value_type
typedef size_t | size_type
typedef T & | reference
typedef const T & | const_reference
typedef T * | pointer
typedef const T * | const_pointer
typedef T * | iterator
typedef const T * | const_iterator
typedef ETL_OR_STD::reverse_iterator< iterator > | reverse_iterator
typedef ETL_OR_STD::reverse_iterator< const_iterator > | const_reverse_iterator
typedef etl::parameter_type< T >::type | parameter_t

## Public Member Functions

reference | front ()
| Returns a reference to the first element.
ETL_CONSTEXPR const_reference | front () const
| Returns a const reference to the first element.
reference | back ()
| Returns a reference to the last element.
ETL_CONSTEXPR const_reference | back () const
| Returns a const reference to the last element.
pointer | data () ETL_NOEXCEPT
| Returns a pointer to the first element of the internal storage.
ETL_CONSTEXPR const_pointer | data () const ETL_NOEXCEPT
| Returns a const pointer to the first element of the internal storage.
iterator | begin () ETL_NOEXCEPT
| Returns an iterator to the beginning of the array.
ETL_CONSTEXPR const_iterator | begin () const ETL_NOEXCEPT
| Returns a const iterator to the beginning of the array.
ETL_CONSTEXPR const_iterator | cbegin () const ETL_NOEXCEPT
| Returns a const iterator to the beginning of the array.
iterator | end () ETL_NOEXCEPT
| Returns an iterator to the end of the array.
ETL_CONSTEXPR const_iterator | end () const ETL_NOEXCEPT
| Returns a const iterator to the end of the array.
ETL_CONSTEXPR const_iterator | cend () const ETL_NOEXCEPT
reverse_iterator | rbegin () ETL_NOEXCEPT
ETL_CONSTEXPR const_reverse_iterator | rbegin () const ETL_NOEXCEPT
| Returns a const reverse iterator to the reverse beginning of the array.
ETL_CONSTEXPR const_reverse_iterator | crbegin () const ETL_NOEXCEPT
| Returns a const reverse iterator to the reverse beginning of the array.
reverse_iterator | rend () ETL_NOEXCEPT
| Returns a reverse iterator to the end of the array.
ETL_CONSTEXPR const_reverse_iterator | rend () const ETL_NOEXCEPT
| Returns a const reverse iterator to the end of the array.
ETL_CONSTEXPR const_reverse_iterator | crend () const ETL_NOEXCEPT
| Returns a const reverse iterator to the end of the array.
ETL_CONSTEXPR size_t | size () const ETL_NOEXCEPT
| Returns the size of the array.
ETL_CONSTEXPR size_t | max_size () const ETL_NOEXCEPT
| Returns the maximum possible size of the array.
reference | operator[] (size_t i) ETL_NOEXCEPT_EXPR(ETL_NOT_USING_EXCEPTIONS||ETL_NOT_CHECKING_INDEX_OPERATOR)
ETL_CONSTEXPR const_reference | operator[] (size_t i) const ETL_NOEXCEPT_EXPR(ETL_NOT_USING_EXCEPTIONS||ETL_NOT_CHECKING_INDEX_OPERATOR)
reference | at (size_t i)
| Returns a reference to the indexed value.
const_reference | at (size_t i) const
| Returns a const reference to the indexed value.
void | fill (parameter_t value)
| Fills the array.
template<typename U, U(&) ARRAYOTHER>
etl::enable_if< etl::is_same< T, U >::value, void >::type | swap (etl::array_wrapper< U, SIZE_, ARRAYOTHER > &other)
| Swaps the contents of arrays.

## Detailed Description

template<typename T, size_t SIZE_, T(&) ARRAY_>
class etl::array_wrapper< T, SIZE_, ARRAY_ >

Array wrapper.

## Member Function Documentation

## operator[]() [1/2]

template<typename T, size_t SIZE_, T(&) ARRAY_>

ETL_CONSTEXPR const_reference etl::array_wrapper< T, SIZE_, ARRAY_ >::operator[] | ( | size_t | i | ) | const

inline

Returns a const reference to the indexed value. If asserts or exceptions are enabled, throws an etl::array_wrapper_bounds if the index is out of bounds.

## operator[]() [2/2]

template<typename T, size_t SIZE_, T(&) ARRAY_>

reference etl::array_wrapper< T, SIZE_, ARRAY_ >::operator[] | ( | size_t | i | ) |

inline

Returns a reference to the indexed value. If asserts or exceptions are enabled, throws an etl::array_wrapper_bounds if the index is out of bounds.

The documentation for this class was generated from the following file:

- include/etl/array_wrapper.h